//-----------------------------------------------------------
#ifndef FrmCubeH
#define FrmCubeH
//-----------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include "D3dVCs.h"
#include <vcl\Dialogs.hpp>
//-----------------------------------------------------------
class TCubeForm : public TForm
{
__published:  // IDE-managed Components
  TStatusBar *StatBar;
  TPanel *paBot;
  TPanel *paRight;
  TSpeedButton *sb1;
  TSpeedButton *sb3;
  TSpeedButton *sb7;
  TSpeedButton *sb8;
  TSpeedButton *sb9;
  TSpeedButton *sb2;
  TSpeedButton *sb6;
  TSpeedButton *sb5;
  TSpeedButton *sb4;
  TPanel *paPlay;
  TSpeedButton *sbHome;
  TSpeedButton *sbBackward;
  TSpeedButton *sbFarward;
  TSpeedButton *sbEnd;
  TPanel *paSetup;
  TSpeedButton *sbSetup;
  TSpeedButton *sbPause;
  TTimer *Timer;
  TSpeedButton *sbAbout;
  TPanel *paStartNew;
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall sb1Click(TObject *Sender);
  void __fastcall sb2Click(TObject *Sender);
  void __fastcall sb3Click(TObject *Sender);
  void __fastcall sb4Click(TObject *Sender);
  void __fastcall sb5Click(TObject *Sender);
  void __fastcall sb6Click(TObject *Sender);
  void __fastcall sb7Click(TObject *Sender);
  void __fastcall sb8Click(TObject *Sender);
  void __fastcall sb9Click(TObject *Sender);
  void __fastcall FormKeyDown(TObject *Sender,
     WORD &Key, TShiftState Shift);
  void __fastcall sbHomeClick(TObject *Sender);
  void __fastcall sbBackwardClick(TObject *Sender);
  void __fastcall sbFarwardClick(TObject *Sender);
  void __fastcall sbEndClick(TObject *Sender);
  void __fastcall sbSetupClick(TObject *Sender);
  void __fastcall TimerTick(TObject *Sender);
  void __fastcall sbAboutClick(TObject *Sender);
  void __fastcall paStartNewClick(TObject *Sender);
private:    // User declarations
  TList *LogList;
  TPanel *paSplit;
  TD3dView *D3dView;
  bool Rotating, StopSeeding;
  TVport *LeftPort, *RightPort;
  int Steps, Dir, PlayStep, StepsDone;
  LPDIRECT3DRMFRAME ICubeCenter, IHandleFrame;
  TDateTime GameTime, LastMoveTime, LastIdleTime;
  void __fastcall RecordMove(int m);
  void __fastcall MakeMove(int m);
  bool __fastcall MakeHandle(int s);
  void __fastcall FreeHandle();
  void __fastcall NewGame();
  void __fastcall Seed();
  void __fastcall Rotate();
  void __fastcall ApplicationIdle(TObject *Sender, bool &Done);
  void __fastcall paSplitMouseUp(TObject *Sender,
     TMouseButton Button, TShiftState Shift, int X, int Y);
public:     // User declarations
  __fastcall TCubeForm(TComponent* Owner);
};
//-----------------------------------------------------------
extern TCubeForm *CubeForm;
//-----------------------------------------------------------
#endif
